//*******************************************************
//	R8C programmer
//
//	MCU:	ATtiny13
//			hfuse:FBh	BOD 2.7V
//			lfuse:32h	9.6MHz
//
//	Compiler:	AVR-GCC		4.3.0
//				AVR-LIBC	1.6.2
//				binutils	2.18
//
//	2009.1.12	KAWAKAMI Yukio
//*******************************************************

#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<avr/pgmspace.h>
#include	<avr/eeprom.h>

#define		NOP		asm volatile("nop\n"::)
#define		WDR		asm volatile("wdr\n"::)
#define		SLEEP	asm volatile("sleep\n"::)

typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;

#define		EEPROM_FREQ	(uint16_t *)1


// |[gݒ(PB)
#define	TXD		4	// PORTB
#define	RXD		3
#define	MODE	2	// PORTB
#define	RESET	1
#define	PRON	0

#define	RESET_HIGH	DDRB &= ~(1<<RESET)
#define	RESET_LOW	DDRB |= (1<<RESET)
#define	MODE_HIGH	DDRB &= ~(1<<MODE)
#define	MODE_LOW	DDRB |= (1<<MODE)
#define	TXD_HIGH	PORTB |= (1<<TXD)
#define	TXD_LOW		PORTB &= ~(1<<TXD)

void wait_10ms(uchar n);

//*******************************************************
//	C[`
//*******************************************************
int main (void) {

	cli();	// 荞݋֎~

	// |[gݒ
	PORTB = (1<<PRON);
	DDRB = 0;

	// ^C}0ݒ
	TCCR0A = 0;
	TCCR0B = (1<<CS02)|(1<<CS00);	// 9.6MHz/1024=9375Hz

	wait_10ms(10);

	// C[v
	for (;;){
		if (PINB & (1<<PRON)){
			// PRON = High	vO~O[h
			MODE_LOW;
			RESET_LOW;
			wait_10ms(10);			// 100msԑ҂
			RESET_HIGH;
			wait_10ms(7);			// 70msԑ҂
			MODE_HIGH;
			TXD_HIGH;
			DDRB |= (1<<TXD);		// TXDo͐ݒ
			wait_10ms(15);			// 150msԑ҂
			while(PINB & (1<<PRON)){
				while(!(PINB & (1<<MODE))){
					TXD_LOW;
				}
				TXD_HIGH;
				while(!(PINB & (1<<RXD))){
					MODE_LOW;
				}
				MODE_HIGH;
			}
			DDRB &= ~(1<<TXD);		// TXDo͐ݒ
			MODE_HIGH;
			RESET_LOW;
			wait_10ms(10);			// 100msԑ҂
			RESET_HIGH;
		}
	}
}


//*******************************************************
//	10msPʂŎԑ҂
//*******************************************************
void wait_10ms(uchar n){

	while(n > 0){
		// 10msԑ҂
		TCNT0 = 256 - 94;
		TIFR0 |= (1<<TOV0);	// I[o[t[tONA
		while(!(TIFR0 & (1<<TOV0)));
		--n;
	}
}


